#include <fcntl.h>
#include <db.h>
#include <stdio.h>
#include <errno.h>

void dump_worddb()
{
   DB *worddb;
   DBT key, data;
   int ret, i;
   unsigned char *tmp;

   if (!(worddb = dbopen("worddb", O_RDONLY, 0644, DB_HASH, NULL))) {
      fprintf(stderr, "error opening worddb: errno = %d\n", errno);
      return;
   }

   for (ret = (*(worddb->seq))(worddb, &key, &data, R_FIRST);
	ret == 0;
	ret = (*(worddb->seq))(worddb, &key, &data, R_NEXT)) {
      if (data.size%12) {
	 printf("worddb corrupt in entry = \"%.*s\", size = %d\n",
		(int) key.size, (char *) key.data, (int) data.size);;
	 return;
      }

      printf("word = \"%.*s\", count = %d\n",
	     (int) key.size, (char *) key.data, (int) (data.size/12));

      for (i=0; i<data.size; i+=12) {
	 tmp = ((unsigned char *) data.data)+i;
	 printf("  %12ld   %02X%02X%02X%02X %02X%02X%02X%02X\n",
		(long) (tmp[0]<<24)|(tmp[1]<<16)|(tmp[2]<<8)|(tmp[3]),
		tmp[4], tmp[5], tmp[6], tmp[7],
		tmp[8], tmp[9], tmp[10], tmp[11]);
      }
   }
}

void dump_timedb()
{
   DB *timedb;
   DBT key, data;
   int ret, i;
   unsigned char *tmp;

   if (!(timedb = dbopen("timedb", O_RDONLY, 0644, DB_BTREE, NULL))) {
      fprintf(stderr, "error opening timedb: errno = %d\n", errno);
      return;
   }

   for (ret = (*(timedb->seq))(timedb, &key, &data, R_FIRST);
	ret == 0;
	ret = (*(timedb->seq))(timedb, &key, &data, R_NEXT)) {
      tmp = (unsigned char *) key.data;

      if (data.size%12) {
	 printf("timedb corrupt in entry add time = %ld, size = %d\n",
		(long) (tmp[0]<<24)|(tmp[1]<<16)|(tmp[2]<<8)|(tmp[3]),
		(int) data.size/12);
	 return;
      }

      printf("add time = %ld, count = %d\n",
	     (long) (tmp[0]<<24)|(tmp[1]<<16)|(tmp[2]<<8)|(tmp[3]),
	     (int) (data.size/12));

      for (i=0; i<data.size; i+=12) {
	 tmp = ((unsigned char *) data.data)+i;
	 printf("  %12ld   %02X%02X%02X%02X %02X%02X%02X%02X\n",
		(long) (tmp[0]<<24)|(tmp[1]<<16)|(tmp[2]<<8)|(tmp[3]),
		tmp[4], tmp[5], tmp[6], tmp[7],
		tmp[8], tmp[9], tmp[10], tmp[11]);
      }
   }
}

int main(int argc, char *argv[])
{
   dump_worddb();

   printf("\n");

   dump_timedb();

   exit(0);
}
