#ifndef _UTIL_H_
#define _UTIL_H_

#include <sys/types.h>
#include <stdio.h>

/*
 * $Id: util.h,v 1.7 1996/12/11 19:17:58 marc Exp $
 * 
 * Copyright (c) 1996, Marc Horowitz.  All rights reserved.
 * See the LICENSE file in the release for redistribution information.
 */

typedef struct _xbuffer {
   long alloclen, len;
   unsigned char *buf;
} xbuffer;

void xbuffer_alloc(xbuffer *xb);
int xbuffer_append(xbuffer *xb, const unsigned char *data, long len);
int xbuffer_append_str(xbuffer *xb, const char *data);
void xbuffer_free(xbuffer *xb);

int slurp_file(FILE *f, xbuffer *xb);

char *my_strdup(const char *s);
int my_strncasecmp(const char *s1, const char *s2, int n);
void *my_memmem(const void *mem, const void *s, size_t memn, size_t mems);
void *my_memcasemem(const void *mem, const void *s, size_t memn, size_t mems);
void *my_memstr(const void *mem, const char *s, size_t n);

#endif
